#version 330 core
out vec4 fragmentColor;

in vec2 TexCoords;

uniform sampler2D renderedSceneTexture;
uniform sampler2D bloomBluredTexture;
uniform bool isEnabledBloom;
uniform float exposure;
uniform float gamma;

void main()
{             
    vec3 hdrColor = texture(renderedSceneTexture, TexCoords).rgb;      
    vec3 bloomColor = texture(bloomBluredTexture, TexCoords).rgb;
    if(isEnabledBloom)
	{
		// add values
        hdrColor += bloomColor; 
	}
	
    // tone mapping unsing simplyfied reinhard tone mapping
    //vec3 result = (vec3(1.0) - exp( ( -   (hdrColor )    ) * exposure) ) ;
	//vec3 result = hdrColor / 2.0f;
	//vec3 result = (hdrColor / (hdrColor + vec3(0.32f, 0.3f, 0.32f))) ;
	float red = hdrColor.r;
	float green = hdrColor.g;
	float blue = hdrColor.b;

	red = red / (red + exposure);
	green = green / (green + exposure);
	blue = blue / (blue + exposure);

	vec3 result = vec3(red, green, blue);

    // gamma correction   
    result = pow(result, vec3(1.0 / gamma));
	
    fragmentColor = vec4(result, 1.0);
}