#version 330 core
in vec2 TexCoords;

out vec4 FragmentColor;

// Texture sampler
uniform sampler2D frame0;
uniform sampler2D frame1;
uniform sampler2D frame2;
uniform sampler2D frame3;
uniform sampler2D frame4;
uniform float amountOfFrames;

void main()
{
	vec3 color = vec3(0.0f);
	color += vec3( texture(frame0, TexCoords).rgb ) / amountOfFrames;
	color += vec3( texture(frame1, TexCoords).rgb ) / amountOfFrames;
	color += vec3( texture(frame2, TexCoords).rgb ) / amountOfFrames;
	color += vec3( texture(frame3, TexCoords).rgb ) / amountOfFrames;
	color += vec3( texture(frame4, TexCoords).rgb ) / amountOfFrames;
	
	
	FragmentColor = vec4( color , 1.0f);
}