

#version 330 core
layout (location = 0) in vec3 position;
layout (location = 1) in vec3 normal;
layout (location = 2) in vec2 texCoords;

out vec3 Normal;
out vec3 FragmentPosition;
out vec2 TexCoords;

uniform mat4 modelMatrix;
uniform mat4 inverseModelMatrix;
uniform mat4 viewMatrix;
uniform mat4 projectionMatrix;

void main()
{
    gl_Position = projectionMatrix * viewMatrix *  modelMatrix * vec4(position, 1.0f);
    FragmentPosition = vec3(modelMatrix * vec4(position, 1.0f));
    Normal = mat3(transpose(inverseModelMatrix)) * normal;  
    TexCoords = texCoords;
} 

