#version 330 core

out vec4 FragmentColor;
  
in vec2 TexCoords;

uniform sampler2D depthMap;
uniform float nearPlane;
uniform float farPlane;

float LinearizeDepth(float depth)
{
    float z = depth * 2.0 - 1.0; // Back to NDC 
    return (2.0 * nearPlane * farPlane) / (farPlane + nearPlane - z * (farPlane - nearPlane));
}

void main()
{             
    float depthValue = texture(depthMap, TexCoords).r;
    FragmentColor = vec4( vec3(LinearizeDepth(depthValue) / farPlane ), 1.0);
}

// IMPLEMTNING THIS FERTIG. bet near far values to this shader